// Ƃ肠ou\[g

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class BubbleSort2 extends JApplet implements Runnable, ActionListener {

  int[] args =  { 10, 3, 46, 7, 23, 34, 8, 12, 4, 45, 44, 52};
  Color[] cs ={Color.red, Color.orange, Color.green, Color.blue};
  Thread thread = null;
  private boolean threadSuspended=true;

  public void init() {
    JButton step = new JButton("Step");
    step.addActionListener(this);
    getContentPane().setLayout(new FlowLayout());
    getContentPane().add(step);
  }

  public void start() {
    if (thread == null) {
      thread = new Thread(this);
      thread.start();
    }
  }

  public void stop() {
    thread = null;
  }

  public synchronized void actionPerformed(ActionEvent e) {
    threadSuspended=false;
    notify();
  }

  public void paint(Graphics g) {
    int i;

    super.paint(g);
    for(i=0; i<args.length; i++) {
      g.setColor(cs[args[i]%cs.length]);
      g.fillRect(0, i*10+50, args[i]*5, 10);
    }
  }

  public void run() {
    int i, j;
      
    for (i=0; i<args.length-1; i++) {
      for (j=args.length-1; j>i; j--) {
	if (args[j-1]>args[j]) { // XbvB
	  int tmp=args[j-1];
	  args[j-1]=args[j];
	  args[j]=tmp;
	}
	repaint();
	/* repainťŎ~܂ */
	try {
	  synchronized(this) { 
	    while (threadSuspended) {
	      wait();
	    }
	    threadSuspended=true;
	  }
	} catch (InterruptedException e) {}
      }
    }
    thread=null; 
  }
}
