import javax.swing.*;
import java.awt.*;

public class Othello extends JApplet {
  int scale = 40;
  int space = 3;
  int size = 8;
  int[][] state = {{0,1,2,0,1,2,0,1}, {2,0,1,2,0,1,2,0}, {1,2,0,1,2,0,1,2},
	           {0,1,2,0,1,2,0,1}, {2,0,1,2,0,1,2,0}, {1,2,0,1,2,0,1,2},
	           {0,1,2,0,1,2,0,1}, {2,0,1,2,0,1,2,0}};

  public void paint(Graphics g) {
    int i,j;
    
    for (i=0; i<8; i++) {
      for (j=0; j<8; j++) {
	g.setColor(Color.green);
	g.fillRect(i*scale, j*scale, scale, scale);
	g.setColor(Color.black);
	g.drawRect(i*scale, j*scale, scale, scale);
	if (state[i][j]==1) {
	  g.setColor(Color.white);
	  g.fillOval(i*scale+space, j*scale+space,
		     scale-space*2, scale-space*2);
	} else if (state[i][j]==2) {
	  g.setColor(Color.black);
	  g.fillOval(i*scale+space, j*scale+space,
		     scale-space*2, scale-space*2);
	}
      } 
    }
  }
}
